import 'Address.dart';
import 'AddressWithGeoLocation.dart';
import 'GeoCoordinates.dart';

abstract class IGeoLocationService {
  Future<GeoCoordinates?> getGeoCoordinates({double accuracy = 5, int retries = 5});
  Future<AddressWithGeoLocation?> getAddressWithGeoLocation();
  Future<GeoCoordinates?> getGeoCoordinatesFromAddress(Address address);
  Future<List<GeoCoordinates?>> getGeoCoordinatesListFromAddress(Address address);
  Future<Address?> getAddressFromGeoCoordinates(GeoCoordinates location);
  Future<Address?> getAddress({
    required double longitude,
    required double latitude,
    dynamic options,
  });
  Future<List<Address?>> getAddressListFromGeoCoordinates(GeoCoordinates location);
  Future<List<Address?>> getAddressList({
    required double longitude,
    required double latitude,
    dynamic options,
  });
}
